/*
 * This is a module which is used for marking skb's.
 */
#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/ip.h>
#include <net/icmp.h>
#include <net/udp.h>
#include <net/tcp.h>
#include "ip_tables.h"

#include "ipt_MARK.h"

static int ipt_mark_target(struct sk_buff *skb,
			   const char *indev,
			   const char *outdev,
			   const union ipt_targinfo *info,
			   unsigned int pos)
{
	skb->nfmark = ((struct ipt_mark_info *)info)->mark;
	return pos + 1;
}

static int ipt_mark_checkentry(const union ipt_targinfo *info,
			      unsigned int pos,
			      unsigned int finalpos)
{
	return 1;
}

static struct ipt_target ipt_mark_reg
= { NULL, "MARK", ipt_mark_target, ipt_mark_checkentry, NULL, &__this_module };

int init_module(void)
{
    if (ipt_register_target(&ipt_mark_reg))
	return -EINVAL;

    return 0;
}

void cleanup_module(void)
{
    ipt_unregister_target(&ipt_mark_reg);
}
