#ifndef _IP_STATE_CORE_H
#define _IP_STATE_CORE_H
/* This header is used to share core functionality between the
   standalone state tracking module, and the compatibility layer's use
   of state tracking. */
extern unsigned int ip_state_in(unsigned int hooknum,
				struct sk_buff **pskb,
				const struct device *in,
				const struct device *out);

extern void ip_state_init(void);
extern void ip_state_cleanup(void);

struct ip_state_protocol;
extern struct ip_state_protocol *find_proto(u_int8_t protocol);
extern struct ip_state_protocol *protocol_list;

extern int icmp_error_track(struct sk_buff *skb);
extern int get_tuple(const struct iphdr *iph, size_t len,
		     struct ip_state_tuple *tuple,
		     struct ip_state_protocol *protocol);
#endif /* _IP_STATE_CORE_H */
