/* Header for use in defining a given protocol for state tracking. */
#ifndef _IP_STATE_PROTOCOL_H
#define _IP_STATE_PROTOCOL_H

struct ip_state_protocol;

/* Protocol registration. */
extern int ip_state_protocol_register(struct ip_state_protocol *proto);
extern void ip_state_protocol_unregister(struct ip_state_protocol *proto);

/* Existing built-in protocols */
extern struct ip_state_protocol ip_state_protocol_tcp;
extern struct ip_state_protocol ip_state_protocol_udp;
extern struct ip_state_protocol ip_state_protocol_icmp;
extern void ip_state_protocol_tcp_init(void);
#endif /*_IP_STATE_PROTOCOL_H*/
