/* Simple generic binding: hands to correct protocol. */

static unsigned int 
generic_print(char *buffer, const struct ip_nat_perconn *perconn)
{
	struct ip_nat_proto *proto=find_proto(perconn->by_ip_and_proto.proto);

	return proto->bindtype.print_private(buffer, perconn);
}

static int generic_check(const struct ip_nat_binding *bind,
			 unsigned int typenumber)
{
	/* We must be the final one. */
	if (bind->elem.type[typenumber+1]) {
		DEBUGP("ipnat_bind_generic_check: must be final.\n");
		return 0;
	}

	return 1;
}

static unsigned int generic_bind(const struct iphdr *iph,
				 const struct ip_nat_pktinfo *pkt,
				 const struct ip_nat_binding_element *cause,
				 struct ip_nat_multi_range *mr,
				 unsigned int typenumber,
				 struct ip_nat_perconn **perconn)
{
	return find_proto(iph->protocol)->bindtype.bind(iph, pkt, cause, mr, 
							typenumber, perconn);
}

/* Don't care if they destroy a perconn. */
static void generic_destroy(const struct ip_nat_perconn *perconn)
{
}

static struct ip_nat_bind_type bind_generic
= { NULL, "generic", 0, &__this_module, 0, 0, 
    generic_print, 
    generic_check, 
    generic_bind,
    generic_destroy };
