/* Compatibility framework for ipchains and ipfwadm support. */

static struct firewall_ops *fwops;
int *(fwctl)(int cmd, void *m, int len);

/* They call these; we do what they want. */
int register_firewall(int pf, struct firewall_ops *fw, 
		      int *(ctl)(int cmd, void *m, int len))
{
	if (pf != PF_INET) {
		printk("Attempt to register non-IP firewall module.\n");
		return -EINVAL;
	}
	if (fw) {
		printk("Attempt to register multiple firewall modules.\n");
		return -EBUSY;
	}

	fwops = fw;
	fwctl = ctl;
}

int unregister_firewall(int pf, struct firewall_ops *fw)
{
	fwops = NULL;
	fwctl = NULL;

	return 0;
}


	


int init_module(void)
{

}

void cleanup_module(void)
{
}

