/* Simple generic rule: hands to correct protocol. */

static unsigned int
generic_print(char *buffer, const struct ip_nat_binding *binding)
{
	struct ip_nat_proto *proto=find_proto(binding->by_ip_and_proto.proto);

	return proto->mappingtype.print_private(buffer, binding);
}

static int generic_check(const struct ip_nat_rule *rule,
			 unsigned int typenumber)
{
	/* We must be the final one. */
	if (rule->elem.type[typenumber+1]) {
		DEBUGP("ipnat_rule_generic_check: must be final.\n");
		return 0;
	}

	return 1;
}

static unsigned int generic_rule(const struct iphdr *iph,
				 const struct ip_nat_pktinfo *pkt,
				 const struct ip_nat_rule_element *cause,
				 struct ip_nat_multi_range *mr,
				 unsigned int typenumber,
				 struct ip_nat_binding **binding)
{
	return find_proto(iph->protocol)->mappingtype.rule(iph, pkt, cause, mr,
							   typenumber,
							   binding);
}

static struct ip_nat_mapping_type mapping_generic
= { NULL, "generic", 0, &__this_module, 0, 0,
    generic_print,
    generic_check,
    generic_rule,
    NULL };
