/* Header for TCP state tracking. */
#ifndef _IP_STATE_TCP_H
#define _IP_STATE_TCP_H

struct ip_state;
struct tcphdr;

struct ip_state_tcp_helper
{	
	/* Internal use. */
	struct ip_state_tcp_helper *next;

	/* Destination port in network order. */
	u_int16_t port; 

	/* Function to call when data passes; return verdict. */
	unsigned int (*established)(const struct tcphdr *, size_t len,
				    int dir, struct ip_state *state,
				    enum ip_statetype *statetype,
				    struct ip_state_expect *expect);
};

extern int ip_state_tcp_helper_register(struct ip_state_tcp_helper *);
extern void ip_state_tcp_helper_unregister(struct ip_state_tcp_helper *);
#endif /*_IP_STATE_TCP_H*/
