/* Very simple allocator; works well for trivial usages. */
#include <linux/types.h>
#include "struct_reserve.h"

extern size_t 
__struct_reserve(size_t *extra, size_t size)
{
	size_t ret = *extra;
	size = (size+1) & ~(sizeof(void *) - 1);

	*extra += size;
	return ret;
}

extern void
__struct_unreserve(size_t *extra, size_t offset, size_t size)
{
	size = (size+1) & ~(sizeof(void *) - 1);

	if (offset + size == *extra)
		*extra -= size;
}
